package edu.jhu.cs.oose.group3.intelligentbook.services;

import java.util.List;

import edu.jhu.cs.oose.group3.intelligentbook.dao.ContactDao;
import edu.jhu.cs.oose.group3.intelligentbook.dao.ContactGroupDao;
import edu.jhu.cs.oose.group3.intelligentbook.dao.ContactItemDao;
import edu.jhu.cs.oose.group3.intelligentbook.model.Contact;
import edu.jhu.cs.oose.group3.intelligentbook.model.ContactGroup;
import edu.jhu.cs.oose.group3.intelligentbook.model.ContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.FirstNameContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.HometownContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.LastNameContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.MiddleNameContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.NicknameContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.PhoneContactItem;

/**
 * Provides general services related to Contact.
 */
public class ContactService {
	private ContactDao contactDao;
	private ContactItemDao contactItemDao;
	private ContactGroupDao contactGroupDao;
	
	/**
	 * @param contactDao the contactDao to set
	 */
	public void setContactDao(ContactDao contactDao) {
		this.contactDao = contactDao;
	}

	/**
	 * @param contactItemDao the contactItemDao to set
	 */
	public void setContactItemDao(ContactItemDao contactItemDao) {
		this.contactItemDao = contactItemDao;
	}


	
	/**
	 * @param contactGroupDao the contactGroupDao to set
	 */
	public void setContactGroupDao(ContactGroupDao contactGroupDao) {
		this.contactGroupDao = contactGroupDao;
	}

	@SuppressWarnings("unchecked")
	public List getAllContacts() {
		return this.contactDao.getAll();
	}

	public boolean addContact(String firstName, String lastName, String phone) {
		Contact c = new Contact();
		
		ContactItem ci = new FirstNameContactItem(firstName);
		c.addContactItem(ci.getName(),ci);
		this.contactItemDao.save(ci);
		
		ci = new LastNameContactItem(lastName);
		c.addContactItem(ci.getName(),ci);
		this.contactItemDao.save(ci);
		
		ci = new PhoneContactItem(phone);
		c.addContactItem(ci.getName(),ci);
		this.contactItemDao.save(ci);
		
		this.contactDao.save(c);
		return true;
		
	}

	public void update(Contact c) {
		for (ContactGroup g : c.getAllGroups())
			contactGroupDao.save(g);
		for (ContactItem ci : c.getAllContactItems().values())
			contactItemDao.save(ci);
		contactDao.save(c);
	}

}
