package edu.jhu.cs.oose.group3.intelligentbook.model;

/** Represents physical address.
 * 
 * Divided into several components to allow fine-grained control over visibility
 * (e.g. let a certain group see the city and country but not the entire address )
 *  */
public class AddressContactItem extends ContactItem {
	
	private CompanyContactItem company;
	private StreetContactItem street;
	private CityContactItem city;
	private ZipContactItem zip;
	private StateContactItem state;
	private CountryContactItem country;

	/**Get the company component of the address*/
	public CompanyContactItem getCompanyContactItem() {
		return company;
	}
	/**Set the company component of the address*/
	public void setCompanyContactItem(CompanyContactItem company) {
		this.company = company;
	}
	/**Get the street component of the address*/
	public StreetContactItem getStreetContactItem() {
		return street;
	}
	
	public void setStreetContactItem(StreetContactItem streetAddress) {
		this.street = streetAddress;
	}
	/**Get the city component of the address*/
	public CityContactItem getCityContactItem() {
		return city;
	}
	/**Set the city component of the address*/
	public void setCityContactItem(CityContactItem city) {
		this.city = city;
	}
	/**Get the state component of the address*/
	public StateContactItem getStateContactItem() {
		return state;
	}
	/**Set the state component of the address*/
	public void setStateContactItem(StateContactItem state) {
		this.state = state;
	}
	/**Get the country component of the address*/
	public CountryContactItem getCountryContactItem() {
		return country;
	}
	/**Set the country component of the address*/
	public void setCountryContactItem(CountryContactItem country) {
		this.country = country;
	}
	/**Get the zip component of the address*/
	public ZipContactItem getZipContactItem() {
		return zip;
	}
	/**Set the zip component of the address*/
	public void setZipContactItem(ZipContactItem zip) {
		this.zip = zip;
	}
}
