package edu.jhu.cs.oose.group3.intelligentbook.model;

import java.util.Set;

import javax.persistence.Basic;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;

/**
 * Represents a group of contacts This group is associated with and maintained
 * by a particular user
 */
@Entity
@Inheritance(strategy = InheritanceType.SINGLE_TABLE)
@DiscriminatorColumn(name = "cgtype", discriminatorType = DiscriminatorType.STRING)
public abstract class ContactGroup {
	@Id
	@GeneratedValue
	long groupId;
	
	@Basic
	protected String name;

	public String getGroupName() {
		return name;
	}

	/** The user can rename a group */
	public void setGroupName(String name) {
		this.name = name;
	}

	/** Returns whether or not the specified contact is in the group */
	public abstract boolean hasContact(Contact c);

	/** Return a set of all contacts in the group */
	public abstract Set<Contact> getAllContacts();

}
