package edu.jhu.cs.oose.group3.intelligentbook.model;

/**
 * Represents a contact item that can have more than one instance in a contact.
 * Since there can be multiple nonsingular contact items, it makes sense to
 * assign a type to each one
 */
public abstract class NonsingularContactItem extends ContactItem {
	public NonsingularContactItem() {
	}

	public NonsingularContactItem(String contents) {
		super(contents);
	}

	public NonsingularContactItem(String type, String contents) {
		super(contents);
		this.type = type;
	}

	private String type;

	/** Get the type of this contact item */
	public String getType() {
		return type;
	}

	/** Set the type of this contact item */
	public void setType(String type) {
		this.type = type;
	}

}
