package edu.jhu.cs.oose.group3.intelligentbook.backingbeans;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.faces.model.SelectItem;

import edu.jhu.cs.oose.group3.intelligentbook.model.Contact;
import edu.jhu.cs.oose.group3.intelligentbook.model.ContactGroup;
import edu.jhu.cs.oose.group3.intelligentbook.model.ContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.FirstNameContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.HometownContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.LastNameContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.MiddleNameContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.model.NicknameContactItem;
import edu.jhu.cs.oose.group3.intelligentbook.services.ContactService;

/** Backing bean for the form to add or edit basic contact information*/
public class AddContactBasicBackingBean {
	private List<SelectItem> visibilityGroups;
	private String firstName;
	private String[] firstNameVisibility;
	private String lastName;
	private String[] lastNameVisibility;
	private String middleName;
	private String[] middleNameVisibility;
	private String nickname;
	private String[] nicknameVisibility;
	private String hometown;
	private String[] hometownVisibility;
	private String birthday;
	private String[] birthdayVisibility;
	
	private Contact currentUser;
	
	private ContactService contactService;
	
	public void updateContact() {
		ContactItem ci;
		
		ci = new FirstNameContactItem(getFirstName());		
		currentUser.addContactItem("First Name",ci);
		currentUser.addContactItemVisibilitiesFromStrings(ci,firstNameVisibility);
		
		ci = new LastNameContactItem(getLastName());
		currentUser.addContactItem("Last Name",ci);
		currentUser.addContactItemVisibilitiesFromStrings(ci,lastNameVisibility);
		
		ci = new MiddleNameContactItem(getMiddleName());
		currentUser.addContactItem("Middle Name",ci);
		currentUser.addContactItemVisibilitiesFromStrings(ci,middleNameVisibility);
		
		ci = new NicknameContactItem(getNickname());
		currentUser.addContactItem("Nickname",ci);
		currentUser.addContactItemVisibilitiesFromStrings(ci,nicknameVisibility);
		
		ci = new HometownContactItem(getHometown());
		currentUser.addContactItem("Hometown",ci);
		currentUser.addContactItemVisibilitiesFromStrings(ci,hometownVisibility);
		
		ci = new NicknameContactItem(getBirthday());
		currentUser.addContactItem("Birthday",ci);
		currentUser.addContactItemVisibilitiesFromStrings(ci,birthdayVisibility);
		
		contactService.update(currentUser);

	}	


	/**
	 * @return the visibilityGroups
	 */
	public List<SelectItem> getVisibilityGroups() {
		return visibilityGroups;
	}

	/**
	 * @param visibilityGroups the visibilityGroups to set
	 */
	public void setVisibilityGroups(List<SelectItem> visibilityGroups) {
		this.visibilityGroups = visibilityGroups;
	}

	/**
	 * @return the firstName
	 */
	public String getFirstName() {
		return firstName;
	}

	/**
	 * @param firstName the firstName to set
	 */
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}

	/**
	 * @return the firstNameVisibility
	 */
	public String[] getFirstNameVisibility() {
		return firstNameVisibility;
	}

	/**
	 * @param firstNameVisibility the firstNameVisibility to set
	 */
	public void setFirstNameVisibility(String[] firstNameVisibility) {
		this.firstNameVisibility = firstNameVisibility;
	}

	/**
	 * @return the lastName
	 */
	public String getLastName() {
		return lastName;
	}

	/**
	 * @param lastName the lastName to set
	 */
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}

	/**
	 * @return the lastNameVisibility
	 */
	public String[] getLastNameVisibility() {
		return lastNameVisibility;
	}

	/**
	 * @param lastNameVisibility the lastNameVisibility to set
	 */
	public void setLastNameVisibility(String[] lastNameVisibility) {
		this.lastNameVisibility = lastNameVisibility;
	}

	/**
	 * @return the middleName
	 */
	public String getMiddleName() {
		return middleName;
	}

	/**
	 * @param middleName the middleName to set
	 */
	public void setMiddleName(String middleName) {
		this.middleName = middleName;
	}

	/**
	 * @return the middleNameVisibility
	 */
	public String[] getMiddleNameVisibility() {
		return middleNameVisibility;
	}

	/**
	 * @param middleNameVisibility the middleNameVisibility to set
	 */
	public void setMiddleNameVisibility(String[] middleNameVisibility) {
		this.middleNameVisibility = middleNameVisibility;
	}

	/**
	 * @return the nickname
	 */
	public String getNickname() {
		return nickname;
	}

	/**
	 * @param nickname the nickname to set
	 */
	public void setNickname(String nickname) {
		this.nickname = nickname;
	}

	/**
	 * @return the nicknameVisibility
	 */
	public String[] getNicknameVisibility() {
		return nicknameVisibility;
	}

	/**
	 * @param nicknameVisibility the nicknameVisibility to set
	 */
	public void setNicknameVisibility(String[] nicknameVisibility) {
		this.nicknameVisibility = nicknameVisibility;
	}

	/**
	 * @return the hometown
	 */
	public String getHometown() {
		return hometown;
	}

	/**
	 * @param hometown the hometown to set
	 */
	public void setHometown(String hometown) {
		this.hometown = hometown;
	}

	/**
	 * @return the hometownVisibility
	 */
	public String[] getHometownVisibility() {
		return hometownVisibility;
	}

	/**
	 * @param hometownVisibility the hometownVisibility to set
	 */
	public void setHometownVisibility(String[] hometownVisibility) {
		this.hometownVisibility = hometownVisibility;
	}

	/**
	 * @return the currentUser
	 */
	public Contact getCurrentUser() {
		return currentUser;
	}

	/**
	 * @param currentUser the currentUser to set
	 */
	public void setCurrentUser(Contact currentUser) {
		this.currentUser = currentUser;
		
		visibilityGroups = new ArrayList<SelectItem>();
		List<ContactGroup> groups = currentUser.getAllGroups();
		for (ContactGroup g : groups) {
			visibilityGroups.add(new SelectItem(g.getGroupName(),g.getGroupName()));
		}
	}
	
	/**
	 * @return the birthday
	 */
	public String getBirthday() {
		return birthday;
	}

	/**
	 * @param birthday the birthday to set
	 */
	public void setBirthday(String birthday) {
		this.birthday = birthday;
	}

	/**
	 * @return the birthdayVisibility
	 */
	public String[] getBirthdayVisibility() {
		return birthdayVisibility;
	}

	/**
	 * @param birthdayVisibility the birthdayVisibility to set
	 */
	public void setBirthdayVisibility(String[] birthdayVisibility) {
		this.birthdayVisibility = birthdayVisibility;
	}



	public void setContactService(ContactService contactService) {
		this.contactService = contactService;
	}



	public ContactService getContactService() {
		return contactService;
	}


}
